/* Input */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input) {
  width: 100%;

  margin: 0;
  padding: var(--margin-sm);

  display: block;

  border: none;
  border-radius: var(--border-radius);
  outline: var(--border-size) solid var(--input-border-color);
  background-color: var(--input-background-color);

  font-family: inherit;
  font-size: 1rem;
  color: inherit;
  resize: none;

  --input-border-color: transparent;
  --input-background-color: var(--color-background-l2);
}

/* Input - Focused */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input):is(:focus, :focus-within) {
  --input-border-color: var(--color-secondary-h1);
}

/* Bordered input */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input).bordered {
  border: var(--border-size) solid var(--input-border-color);
  outline: none;

  --input-border-color: var(--color-secondary-h1);
}

:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input).bordered:is(:focus, :focus-within) {
  --input-border-color: var(--color-secondary-h2);
}

/* Transparent input */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input).transparent {
  outline: none;
  background-color: transparent;
}

/* Large input */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input).display-1 {
  font-size: 1.8rem;
  font-family: "Oswald", sans-serif;
}

@media (width >= 940px) {
  :where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select, .input).display-1 {
    font-size: 4rem;
    line-height: 4rem;
  }
}

/* Input with icons */
:where(input, .input):is(.icon-comment, .icon-search, .icon-soup, .icon-tag, .icon-time, .icon-weight) {
  padding-left: 2.5em;

  background-repeat: no-repeat;
  background-size: 1.4rem;
  background-position: var(--margin-sm) center;
}

:where(input, .input).icon-comment {
  background-image: url("/img/comment.svg");
}

:where(input, .input).icon-search {
  background-image: url("/img/search-light.svg");
}

[data-theme="dark"] :where(input, .input).icon-search {
  background-image: url("/img/search-dark.svg");
}

:where(input, .input).icon-soup {
  background-image: url("/img/soup-light.svg");
}

[data-theme="dark"] :where(input, .input).icon-soup {
  background-image: url("/img/soup-dark.svg");
}

:where(input, .input).icon-tag {
  background-image: url("/img/tag-light.svg");
}

[data-theme="dark"] :where(input, .input).icon-tag {
  background-image: url("/img/tag-dark.svg");
}

:where(input, .input).icon-time {
  background-image: url("/img/time-light.svg");
}

[data-theme="dark"] :where(input, .input).icon-time {
  background-image: url("/img/time-dark.svg");
}

:where(input, .input).icon-weight {
  background-image: url("/img/weight.svg");
}

/* Select */
select {
  appearance: none;

  background-image: url("/img/arrow-down-light.svg");
  background-repeat: no-repeat;
  background-size: 1.4rem;
  background-position: right var(--margin-sm) center;
}

[data-theme="dark"] select {
  background-image: url("/img/arrow-down-dark.svg");
}

/* Select with icon */
select.icon-egg {
  padding-left: 2.5em;

  background-image: url("/img/egg-light.svg"), url("/img/arrow-down-light.svg");
  background-position: var(--margin-sm) center, right var(--margin-sm) center;
}

[data-theme="dark"] select.icon-egg {
  background-image: url("/img/egg-dark.svg"), url("/img/arrow-down-dark.svg");
}

/* Input - Validation */
:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select).invalid {
  --input-border-color: var(--color-border-danger);
}

:where(input[type="text"], input[type="password"], input[type="email"], input[type="search"], textarea, select).invalid:focus {
  --input-border-color: var(--color-border-danger);
}